content = document.getElementById('content');
notes = null;
html = null;

if (typeof window.init === 'undefined') {
	window.init = function() {
		if (typeof rangy === 'undefined') {
			var scr = document.createElement('script');
			document.body.appendChild(scr).src = 'file:///android_asset/rangy/undo.js';
			scr = document.createElement('script');
			scr.onload = function() {
				var scr = document.createElement('script');
				scr.onload = function() {
					rangy.init();
					initUndo();
					if (mysword) mysword.log('rangy')
				};
				document.body.appendChild(scr).src = 'file:///android_asset/rangy/rangy-classapplier.js'
			}
			document.body.appendChild(scr).src = 'file:///android_asset/rangy/rangy-core.js'
		};
	}

	window.initUndo = function() {
		var startValue = content.innerHTML;
		var lastValue = startValue;
		var blocked = false;
		stack = new Undo.Stack();

		observer = new MutationObserver(function (mutations) {
			var newValue = content.innerHTML;
			// Average word length in English language is 5.1
			var log = content.contentEditable !== 'true' ||
				Math.abs(newValue.length - lastValue.length) >= 5 ||
				Math.abs(newValue.length - startValue.length) >= 5;
			if (!blocked && log) {
				stack.execute(new EditCommand(content, lastValue, newValue));
				lastValue = newValue;
			}
			startValue = newValue;
			blocked = false;
		});

		observer.observe(content, {
			attributes: true,
			childList: true,
			characterData: true,
			//characterDataOldValue: true,
			subtree: true
		});

		var EditCommand = Undo.Command.extend({
			constructor: function (textarea, oldValue, newValue) {
				this.textarea = textarea;
				this.oldValue = oldValue;
				this.newValue = newValue;
			},
			execute: function () {},
			undo: function () {
				blocked = true;
				this.textarea.innerHTML = this.oldValue;
				lastValue = this.oldValue;
			},

			redo: function () {
				blocked = true;
				this.textarea.innerHTML = this.newValue;
				lastValue = this.newValue;
			}
		});
	}

	window.endFormatting = function() {
		observer.disconnect();
		observer = null;
		stack = null;
	}

	window.getNotes = function() {
		var sel = rangy.getSelection();
		if (sel.rangeCount) {
			var el = sel.getRangeAt(0).startContainer.parentNode;
			var tel = null;
			do {
				if (el.nodeType == 1) {
					if (el.classList.contains('tagmod'))
						break;
					else if (el.classList.contains('tag'))
						tel = el;
				}
				el = el.parentNode;
			} while (el);
			if (el) {
				notes = el;
				if (tel)
					mysword.getNotes(tel.innerHTML);
				else
					mysword.getNotes(el.innerHTML);
				return
			} else if (tel) {
				notes = tel;
				mysword.getNotes(tel.innerHTML);
				return
			}
			mysword.getNotes('')
		}
	}

	window.setNotes = function(text) {
		if (notes === null) {
			var sel = rangy.getSelection();
			if (sel.rangeCount) {
				var range = sel.getRangeAt(0);//.cloneRange();
				range.collapse(false);
				var tag = "span";
				if (containsBlock(text))
					tag = "div";
				var el = document.createElement(tag);
				el.className = "tagmod";
				el.innerHTML = createNotes(tag, text);
				range.insertNode(el);
				sel.removeAllRanges();
			}
		} else {
			if (text == '') {
				notes.parentNode.removeChild(notes);
			} else {
				var cls = notes.querySelector(".tag").className;
				if (notes.tagName == "SPAN" && containsBlock(text)) {
					var el = document.createElement("div");
					el.className = "tagmod";
					el.innerHTML = createNotes("div", text);
					notes.parentNode.replaceChild(el, notes);
					notes = el;
				} else {
					notes.className = "tagmod";
					notes.innerHTML = createNotes(notes.tagName, text);
				}
				notes.querySelector(".tag").className = cls;
			}
			notes = null
		}
	}

	window.createNotes = function(tag, text) {
		return "&#8203;<" + tag + " class='tag'>" + text + "</" + tag + ">";
	}

	window.containsBlock = function(text) {
		return text.search(/<(p|div|li|h\d|block|table)/) >= 0;
	}

	window.insertImage = function(url) {
		var sel = rangy.getSelection();
		if (sel.rangeCount) {
			var range = sel.getRangeAt(0);//.cloneRange();
			range.collapse(false);
			var el = document.createElement("img");
			el.className = "tagmod";
			el.src = url;
			el.style.minWidth = "32px";
			el.style.width = "1.5em";
			range.insertNode(el);
			sel.removeAllRanges();
		}
	}

	window.getHTML = function() {
		var sel = rangy.getSelection();
		if (sel.rangeCount) {
			var el = sel.getRangeAt(0).commonAncestorContainer;
			var tel = null;
			do {
				if (el.nodeType == 1)
					break;
				el = el.parentNode;
			} while (el);
			if (el) {
				html = el;
				mysword.getHTML(el.innerHTML);
			}
		}
	}

	window.setHTML = function(text) {
		if (html != null) {
			html.innerHTML = text;
			html = null
		}
	}

	window.getContent = function() {
		mysword.getContent(content.innerHTML);
	}

	window.setContent = function(text) {
		content.innerHTML = text;
		content.contentEditable = false;
	}

	window.execCommand = function(command) {
		var editable = content.contentEditable === 'true';
		var cac = null;
		if (!editable) {
			var sel = rangy.getSelection();
			if (sel.rangeCount) {
				cac = sel.getRangeAt(0).commonAncestorContainer;
				if (cac.nodeType != 1)
					cac = cac.parentElement;
				while (cac.tagName == 'B' || cac.tagName == 'I' ||
					cac.tagName == 'U' || cac.tagName == 'SPAN')
					cac = cac.parentElement;
				cac.contentEditable = true;
			} else {
				content.contentEditable = true;
			}
		}
		document.execCommand(command, false, null);
		if (!editable) {
			if (cac != null)
				cac.removeAttribute('contentEditable');
			else
				content.contentEditable = false;
		}
	}

	window.bold = function() {
		execCommand('bold');
	}

	window.italic = function() {
		execCommand('italic');
	}

	window.underline = function() {
		execCommand('underline');
	}

	window.undo = function() {
		if (stack.canUndo())
			stack.undo();
	}

	window.redo = function() {
		if (stack.canRedo())
			stack.redo();
	}

	window.removeFormat = function() {
		execCommand('removeFormat');
		var cont = selectedHTML();
		['red','orange','brown','yellowgreen','green','bluegreen','blue','violet','purple','pink','gray',
			'h1','h2','h3','h4','h5','h6','h7','h8','h9','h10',
			'bx','bx1','bx2','bx3','bx4','bx5','bx6','bx7','bx8','bx9','bx10','bx11']
			.forEach(function (i) {
				if (cont.indexOf(i) == -1) return;
				var ap = rangy.createClassApplier(i, {tagNames:['span']});
				ap.undoToSelection()
			});
		var sel = rangy.getSelection();
		var nodes = sel.getRangeAt(0).getNodes([1], function (node) {
			return node.nodeType == 1 && (node.classList.contains('tagmod') || node.classList.contains('tag'));
		});
		for (var node of nodes) {
			node.parentNode.removeChild(node);
		}
	}

	window.color = function(css) {
		var ap = rangy.createClassApplier(css, {tagNames:['span']});
		var cont = selectedHTML();
		['red','orange','brown','yellowgreen','green','bluegreen','blue','violet','purple','pink','gray']
			.forEach(function (i) {
				if (i == css) return;
				if (cont.indexOf(i) == -1) return;
				var ap3 = rangy.createClassApplier(i, {tagNames:['span']});
				ap3.undoToSelection()
			});
		ap.applyToSelection()
	}

	window.highlight = function(css) {
		var ap = rangy.createClassApplier(css, {tagNames:['span']});
		// I don't know why the for loop with concatenate string sometimes hang the WebView but it worked on the box below
		// for(var i=1;i<=10;i++){var ap3=rangy.createClassApplier('h'+i,{tagNames:['span']});ap3.undoToSelection()}ap.applyToSelection()
		var cont = selectedHTML();
		['h1','h2','h3','h4','h5','h6','h7','h8','h9','h10']
			.forEach(function (i) {
				if (i == css) return;
				if (cont.indexOf(i) == -1) return;
				var ap3 = rangy.createClassApplier(i, {tagNames:['span']});
				ap3.undoToSelection()
			});
		ap.applyToSelection()
	}

	window.box = function(css) {
		var ap = rangy.createClassApplier('bx', {tagNames:['span']});
		var ap2 = rangy.createClassApplier(css, {tagNames:['span']});
		if (!ap.isAppliedToSelection()) {
			ap.applyToSelection();
			ap2.applyToSelection()
		} else if (!ap2.isAppliedToSelection()) {
			var cont = selectedHTML();
			for (var i=1; i<=11; i++) {
				var style = 'bx'+i;
				if (style == css) continue;
				if (cont.indexOf(style) == -1) continue;
				var ap3 = rangy.createClassApplier(style, {tagNames:['span']});
				ap3.undoToSelection()
			}
			ap2.applyToSelection()
		}
	}

	window.selectedHTML = function() {
		var cont = '';
		var sel = rangy.getSelection();
		if (sel.rangeCount) {
			var range = sel.getRangeAt(0);
			var el = range.commonAncestorContainer;
			if (el.nodeType == 3) el = el.parentNode;
			cont = el.outerHTML;
		}
		return cont;
	}
} else {
	initUndo();
}

init();
